#!/usr/bin/perl
#-------------------------------------------------------------------------------
#
# This small script returns all the short names for the services by port
# ready to be included as a string resource ;)
# It is implicitly called through "stripports.cmd" !!!
#
#-------------------------------------------------------------------------------
# open input file (hardcoded here)
open (inputfile, "port-numbers.txt") || die "File not found";
my $lastport = "";
# for each and every line in the inputfile
while ( $line = <inputfile> ) {
# unless the line starts with #
  unless ($line =~ m/^#.*/) {
    if ($line =~ m/^(.*)\s([0-9]{1,5})\/tcp\s(.*)$/) {
      my $longname = $3;
      my $port = $2;
      my $name = $1;
# prevent any doubles!!! -> THIS COULD BE ENHANCED IN FUTURE
      if ($port ne $lastport) {
        $lastport = $port;
# replace any spaces by nothing
        $name =~ s/\s//gi;
        if ($name eq "") {
          while ($longname =~ m/^ (.*)$/) {
            $longname = $1;
          }
          while ($longname =~ m/^(.*) $/) {
            $longname = $1;
          }
          while ($longname =~ m/^\t(.*)$/) {
            $longname = $1;
          }
          while ($longname =~ m/^(.*)\t$/) {
            $longname = $1;
          }
          $name = "[".$longname."]";
        }
# unless the string is not empty
        unless ($name eq "") {
# print it
          printf "  %5d \"%s\"\n", $port, $name;
        }
      }
    } elsif ($line =~ m/^\(last updated.*$/) {
      print "\/\/".$line;
    }
  }
}
# close our input file
close (inputfile);

